﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.IO;
using System.Linq;
using System.Net.Sockets;
using System.Net;
using System.Runtime.InteropServices;
using System.Text;
using System.Threading;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace WinFileSender
{
    public partial class Form1 : Form
    {
        const int PACKSZ = 4096;

        const byte firstbyte = 0x0a;
        const byte secondbyte = 0x0d;
        const byte thirdbyte = 0xff;

        public Form1()
        {
            InitializeComponent();
        }        

        void StartClient(Object tmphandler)
        {
            string filepath = (string)tmphandler;

            // (1) 소켓 객체 생성 (TCP 소켓)
            Socket sender = new Socket(AddressFamily.InterNetwork, SocketType.Stream, ProtocolType.Tcp);

            try
            {
                IPEndPoint remoteEP = new IPEndPoint(IPAddress.Parse("127.0.0.1"), 21111);
                sender.Connect(remoteEP);

                byte[] buff = new byte[PACKSZ];
                int fileSize = 0;
                string filename = "";

                int kk = 0;
                int count = 0;
                int bytesSent = 0;

                //SEND FILESIZE//SEND FILESIZE//SEND FILESIZE//SEND FILESIZE
                //SEND FILESIZE//SEND FILESIZE//SEND FILESIZE//SEND FILESIZE
                //SEND FILESIZE//SEND FILESIZE//SEND FILESIZE//SEND FILESIZE
                //SEND FILESIZE//SEND FILESIZE//SEND FILESIZE//SEND FILESIZE
                FileInfo info = new FileInfo(filepath);
                fileSize = Convert.ToInt32(info.Length);

                byte[] dataByte = Encoding.UTF8.GetBytes(fileSize.ToString());

                for (kk = 0; kk < dataByte.Length; kk++)
                {
                    buff[kk] = dataByte[kk];
                }
                buff[kk++] = firstbyte;
                buff[kk++] = secondbyte;
                buff[kk++] = thirdbyte;
                bytesSent = sender.Send(buff);

                //SEND FILENAME//SEND FILENAME//SEND FILENAME//SEND FILENAME
                //SEND FILENAME//SEND FILENAME//SEND FILENAME//SEND FILENAME
                //SEND FILENAME//SEND FILENAME//SEND FILENAME//SEND FILENAME
                //SEND FILENAME//SEND FILENAME//SEND FILENAME//SEND FILENAME
                //SEND FILENAME//SEND FILENAME//SEND FILENAME//SEND FILENAME
                filename = Path.GetFileName(filepath);

                byte[] dataByte2 = Encoding.UTF8.GetBytes(filename);

                for (kk = 0; kk < dataByte2.Length; kk++)
                {
                    buff[kk] = dataByte2[kk];
                }
                buff[kk++] = firstbyte;
                buff[kk++] = secondbyte;
                buff[kk++] = thirdbyte;
                bytesSent = sender.Send(buff);



                //SEND FILE READ BY PACKSZ//SEND FILE READ BY PACKSZ//SEND FILE READ BY PACKSZ
                //SEND FILE READ BY PACKSZ//SEND FILE READ BY PACKSZ//SEND FILE READ BY PACKSZ
                //SEND FILE READ BY PACKSZ//SEND FILE READ BY PACKSZ//SEND FILE READ BY PACKSZ
                //SEND FILE READ BY PACKSZ//SEND FILE READ BY PACKSZ//SEND FILE READ BY PACKSZ
                FileStream fs = new FileStream(filepath, FileMode.Open, FileAccess.Read);
                byte[] fileByte = new byte[PACKSZ];
                while ((count = fs.Read(fileByte, 0, PACKSZ)) > 0)
                {
                    if (count == PACKSZ)
                    {
                        bytesSent = sender.Send(fileByte);
                        Console.WriteLine("FILE SZ:" + PACKSZ.ToString("0000") + "/,SEND SZ:" + bytesSent.ToString("0000"));
                    }
                    else if (count < PACKSZ)
                    {
                        byte[] sendByte = new byte[count];
                        Buffer.BlockCopy(fileByte, 0, sendByte, 0, count);
                        bytesSent = sender.Send(sendByte);
                        Console.WriteLine("FILE SZ:" + count.ToString("0000") + "/,SEND SZ:" + bytesSent.ToString("0000"));
                    }
                }

                sender.Shutdown(SocketShutdown.Both);
                sender.Close();
            }
            catch (ArgumentNullException ane)
            {
                Console.WriteLine("ArgumentNullException : {0}", ane.ToString());
            }
            catch (SocketException se)
            {
                Console.WriteLine("SocketException : {0}", se.ToString());
            }
            catch (Exception ex)
            {
                Console.WriteLine("Unexpected exception : {0}", ex.ToString());
            }
        }

        protected override bool ProcessCmdKey(ref Message message, Keys keyData)
        {
            const int WM_KEYDOWN = 0x0100;

            switch (message.Msg)
            {
                case WM_KEYDOWN:
                    if (keyData.ToString() == "Escape")
                    {
                        Application.Exit();
                    }
                    else if (keyData.ToString() == "Return")
                    {
                        string paramStr = @"C:\Users\B210145_BK\Downloads\APMExture_3_0\Bin\Release\AMS.dll";

                        Thread RealSocModel = new Thread(new ParameterizedThreadStart(StartClient));
                        RealSocModel.Start(paramStr);
                    }
                    break;
                default:
                    break;
            }
            return base.ProcessCmdKey(ref message, keyData);
        }
    }
}
